
#include <Python.h>
#include <stddef.h>

/* this block of #ifs should be kept exactly identical between
   c/_cffi_backend.c, cffi/vengine_cpy.py, cffi/vengine_gen.py */
#if defined(_MSC_VER)
# include <malloc.h>   /* for alloca() */
# if _MSC_VER < 1600   /* MSVC < 2010 */
   typedef __int8 int8_t;
   typedef __int16 int16_t;
   typedef __int32 int32_t;
   typedef __int64 int64_t;
   typedef unsigned __int8 uint8_t;
   typedef unsigned __int16 uint16_t;
   typedef unsigned __int32 uint32_t;
   typedef unsigned __int64 uint64_t;
   typedef __int8 int_least8_t;
   typedef __int16 int_least16_t;
   typedef __int32 int_least32_t;
   typedef __int64 int_least64_t;
   typedef unsigned __int8 uint_least8_t;
   typedef unsigned __int16 uint_least16_t;
   typedef unsigned __int32 uint_least32_t;
   typedef unsigned __int64 uint_least64_t;
   typedef __int8 int_fast8_t;
   typedef __int16 int_fast16_t;
   typedef __int32 int_fast32_t;
   typedef __int64 int_fast64_t;
   typedef unsigned __int8 uint_fast8_t;
   typedef unsigned __int16 uint_fast16_t;
   typedef unsigned __int32 uint_fast32_t;
   typedef unsigned __int64 uint_fast64_t;
   typedef __int64 intmax_t;
   typedef unsigned __int64 uintmax_t;
# else
#  include <stdint.h>
# endif
# if _MSC_VER < 1800   /* MSVC < 2013 */
   typedef unsigned char _Bool;
# endif
#else
# include <stdint.h>
# if (defined (__SVR4) && defined (__sun)) || defined(_AIX)
#  include <alloca.h>
# endif
#endif

#if PY_MAJOR_VERSION < 3
# undef PyCapsule_CheckExact
# undef PyCapsule_GetPointer
# define PyCapsule_CheckExact(capsule) (PyCObject_Check(capsule))
# define PyCapsule_GetPointer(capsule, name) \
    (PyCObject_AsVoidPtr(capsule))
#endif

#if PY_MAJOR_VERSION >= 3
# define PyInt_FromLong PyLong_FromLong
#endif

#define _cffi_from_c_double PyFloat_FromDouble
#define _cffi_from_c_float PyFloat_FromDouble
#define _cffi_from_c_long PyInt_FromLong
#define _cffi_from_c_ulong PyLong_FromUnsignedLong
#define _cffi_from_c_longlong PyLong_FromLongLong
#define _cffi_from_c_ulonglong PyLong_FromUnsignedLongLong

#define _cffi_to_c_double PyFloat_AsDouble
#define _cffi_to_c_float PyFloat_AsDouble

#define _cffi_from_c_int_const(x)                                        \
    (((x) > 0) ?                                                         \
        ((unsigned long long)(x) <= (unsigned long long)LONG_MAX) ?      \
            PyInt_FromLong((long)(x)) :                                  \
            PyLong_FromUnsignedLongLong((unsigned long long)(x)) :       \
        ((long long)(x) >= (long long)LONG_MIN) ?                        \
            PyInt_FromLong((long)(x)) :                                  \
            PyLong_FromLongLong((long long)(x)))

#define _cffi_from_c_int(x, type)                                        \
    (((type)-1) > 0 ? /* unsigned */                                     \
        (sizeof(type) < sizeof(long) ?                                   \
            PyInt_FromLong((long)x) :                                    \
         sizeof(type) == sizeof(long) ?                                  \
            PyLong_FromUnsignedLong((unsigned long)x) :                  \
            PyLong_FromUnsignedLongLong((unsigned long long)x)) :        \
        (sizeof(type) <= sizeof(long) ?                                  \
            PyInt_FromLong((long)x) :                                    \
            PyLong_FromLongLong((long long)x)))

#define _cffi_to_c_int(o, type)                                          \
    ((type)(                                                             \
     sizeof(type) == 1 ? (((type)-1) > 0 ? (type)_cffi_to_c_u8(o)        \
                                         : (type)_cffi_to_c_i8(o)) :     \
     sizeof(type) == 2 ? (((type)-1) > 0 ? (type)_cffi_to_c_u16(o)       \
                                         : (type)_cffi_to_c_i16(o)) :    \
     sizeof(type) == 4 ? (((type)-1) > 0 ? (type)_cffi_to_c_u32(o)       \
                                         : (type)_cffi_to_c_i32(o)) :    \
     sizeof(type) == 8 ? (((type)-1) > 0 ? (type)_cffi_to_c_u64(o)       \
                                         : (type)_cffi_to_c_i64(o)) :    \
     (Py_FatalError("unsupported size for type " #type), (type)0)))

#define _cffi_to_c_i8                                                    \
                 ((int(*)(PyObject *))_cffi_exports[1])
#define _cffi_to_c_u8                                                    \
                 ((int(*)(PyObject *))_cffi_exports[2])
#define _cffi_to_c_i16                                                   \
                 ((int(*)(PyObject *))_cffi_exports[3])
#define _cffi_to_c_u16                                                   \
                 ((int(*)(PyObject *))_cffi_exports[4])
#define _cffi_to_c_i32                                                   \
                 ((int(*)(PyObject *))_cffi_exports[5])
#define _cffi_to_c_u32                                                   \
                 ((unsigned int(*)(PyObject *))_cffi_exports[6])
#define _cffi_to_c_i64                                                   \
                 ((long long(*)(PyObject *))_cffi_exports[7])
#define _cffi_to_c_u64                                                   \
                 ((unsigned long long(*)(PyObject *))_cffi_exports[8])
#define _cffi_to_c_char                                                  \
                 ((int(*)(PyObject *))_cffi_exports[9])
#define _cffi_from_c_pointer                                             \
    ((PyObject *(*)(char *, CTypeDescrObject *))_cffi_exports[10])
#define _cffi_to_c_pointer                                               \
    ((char *(*)(PyObject *, CTypeDescrObject *))_cffi_exports[11])
#define _cffi_get_struct_layout                                          \
    ((PyObject *(*)(Py_ssize_t[]))_cffi_exports[12])
#define _cffi_restore_errno                                              \
    ((void(*)(void))_cffi_exports[13])
#define _cffi_save_errno                                                 \
    ((void(*)(void))_cffi_exports[14])
#define _cffi_from_c_char                                                \
    ((PyObject *(*)(char))_cffi_exports[15])
#define _cffi_from_c_deref                                               \
    ((PyObject *(*)(char *, CTypeDescrObject *))_cffi_exports[16])
#define _cffi_to_c                                                       \
    ((int(*)(char *, CTypeDescrObject *, PyObject *))_cffi_exports[17])
#define _cffi_from_c_struct                                              \
    ((PyObject *(*)(char *, CTypeDescrObject *))_cffi_exports[18])
#define _cffi_to_c_wchar_t                                               \
    ((wchar_t(*)(PyObject *))_cffi_exports[19])
#define _cffi_from_c_wchar_t                                             \
    ((PyObject *(*)(wchar_t))_cffi_exports[20])
#define _cffi_to_c_long_double                                           \
    ((long double(*)(PyObject *))_cffi_exports[21])
#define _cffi_to_c__Bool                                                 \
    ((_Bool(*)(PyObject *))_cffi_exports[22])
#define _cffi_prepare_pointer_call_argument                              \
    ((Py_ssize_t(*)(CTypeDescrObject *, PyObject *, char **))_cffi_exports[23])
#define _cffi_convert_array_from_object                                  \
    ((int(*)(char *, CTypeDescrObject *, PyObject *))_cffi_exports[24])
#define _CFFI_NUM_EXPORTS 25

typedef struct _ctypedescr CTypeDescrObject;

static void *_cffi_exports[_CFFI_NUM_EXPORTS];
static PyObject *_cffi_types, *_cffi_VerificationError;

static int _cffi_setup_custom(PyObject *lib);   /* forward */

static PyObject *_cffi_setup(PyObject *self, PyObject *args)
{
    PyObject *library;
    int was_alive = (_cffi_types != NULL);
    (void)self; /* unused */
    if (!PyArg_ParseTuple(args, "OOO", &_cffi_types, &_cffi_VerificationError,
                                       &library))
        return NULL;
    Py_INCREF(_cffi_types);
    Py_INCREF(_cffi_VerificationError);
    if (_cffi_setup_custom(library) < 0)
        return NULL;
    return PyBool_FromLong(was_alive);
}

static int _cffi_init(void)
{
    PyObject *module, *c_api_object = NULL;

    module = PyImport_ImportModule("_cffi_backend");
    if (module == NULL)
        goto failure;

    c_api_object = PyObject_GetAttrString(module, "_C_API");
    if (c_api_object == NULL)
        goto failure;
    if (!PyCapsule_CheckExact(c_api_object)) {
        PyErr_SetNone(PyExc_ImportError);
        goto failure;
    }
    memcpy(_cffi_exports, PyCapsule_GetPointer(c_api_object, "cffi"),
           _CFFI_NUM_EXPORTS * sizeof(void *));

    Py_DECREF(module);
    Py_DECREF(c_api_object);
    return 0;

  failure:
    Py_XDECREF(module);
    Py_XDECREF(c_api_object);
    return -1;
}

#define _cffi_type(num) ((CTypeDescrObject *)PyList_GET_ITEM(_cffi_types, num))

/**********/



#include <inttypes.h>
#include <linux/fs.h>
#include <linux/fiemap.h>


static int _cffi_const_FIEMAP_EXTENT_DATA_ENCRYPTED(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_DATA_ENCRYPTED);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_DATA_ENCRYPTED", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return ((void)lib,0);
}

static int _cffi_const_FIEMAP_EXTENT_DATA_INLINE(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_DATA_INLINE);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_DATA_INLINE", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_DATA_ENCRYPTED(lib);
}

static int _cffi_const_FIEMAP_EXTENT_DATA_TAIL(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_DATA_TAIL);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_DATA_TAIL", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_DATA_INLINE(lib);
}

static int _cffi_const_FIEMAP_EXTENT_DELALLOC(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_DELALLOC);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_DELALLOC", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_DATA_TAIL(lib);
}

static int _cffi_const_FIEMAP_EXTENT_ENCODED(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_ENCODED);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_ENCODED", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_DELALLOC(lib);
}

static int _cffi_const_FIEMAP_EXTENT_LAST(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_LAST);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_LAST", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_ENCODED(lib);
}

static int _cffi_const_FIEMAP_EXTENT_MERGED(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_MERGED);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_MERGED", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_LAST(lib);
}

static int _cffi_const_FIEMAP_EXTENT_NOT_ALIGNED(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_NOT_ALIGNED);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_NOT_ALIGNED", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_MERGED(lib);
}

static int _cffi_const_FIEMAP_EXTENT_SHARED(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_SHARED);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_SHARED", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_NOT_ALIGNED(lib);
}

static int _cffi_const_FIEMAP_EXTENT_UNKNOWN(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_UNKNOWN);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_UNKNOWN", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_SHARED(lib);
}

static int _cffi_const_FIEMAP_EXTENT_UNWRITTEN(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_EXTENT_UNWRITTEN);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_EXTENT_UNWRITTEN", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_UNKNOWN(lib);
}

static int _cffi_const_FIEMAP_FLAGS_COMPAT(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_FLAGS_COMPAT);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_FLAGS_COMPAT", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_EXTENT_UNWRITTEN(lib);
}

static int _cffi_const_FIEMAP_FLAG_SYNC(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_FLAG_SYNC);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_FLAG_SYNC", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_FLAGS_COMPAT(lib);
}

static int _cffi_const_FIEMAP_FLAG_XATTR(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_FLAG_XATTR);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_FLAG_XATTR", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_FLAG_SYNC(lib);
}

static int _cffi_const_FIEMAP_MAX_OFFSET(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FIEMAP_MAX_OFFSET);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FIEMAP_MAX_OFFSET", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_FLAG_XATTR(lib);
}

static int _cffi_const_FS_IOC_FIEMAP(PyObject *lib)
{
  PyObject *o;
  int res;
  o = _cffi_from_c_int_const(FS_IOC_FIEMAP);
  if (o == NULL)
    return -1;
  res = PyObject_SetAttrString(lib, "FS_IOC_FIEMAP", o);
  Py_DECREF(o);
  if (res < 0)
    return -1;
  return _cffi_const_FIEMAP_MAX_OFFSET(lib);
}

static void _cffi_check_struct_fiemap(struct fiemap *p)
{
  /* only to generate compile-time warnings or errors */
  (void)p;
  (void)((p->fm_start) << 1);
  (void)((p->fm_length) << 1);
  (void)((p->fm_flags) << 1);
  (void)((p->fm_mapped_extents) << 1);
  (void)((p->fm_extent_count) << 1);
  { struct fiemap_extent(*tmp)[0] = &p->fm_extents; (void)tmp; }
}
static PyObject *
_cffi_layout_struct_fiemap(PyObject *self, PyObject *noarg)
{
  struct _cffi_aligncheck { char x; struct fiemap y; };
  static Py_ssize_t nums[] = {
    sizeof(struct fiemap),
    offsetof(struct _cffi_aligncheck, y),
    offsetof(struct fiemap, fm_start),
    sizeof(((struct fiemap *)0)->fm_start),
    offsetof(struct fiemap, fm_length),
    sizeof(((struct fiemap *)0)->fm_length),
    offsetof(struct fiemap, fm_flags),
    sizeof(((struct fiemap *)0)->fm_flags),
    offsetof(struct fiemap, fm_mapped_extents),
    sizeof(((struct fiemap *)0)->fm_mapped_extents),
    offsetof(struct fiemap, fm_extent_count),
    sizeof(((struct fiemap *)0)->fm_extent_count),
    offsetof(struct fiemap, fm_extents),
    sizeof(((struct fiemap *)0)->fm_extents),
    -1
  };
  (void)self; /* unused */
  (void)noarg; /* unused */
  return _cffi_get_struct_layout(nums);
  /* the next line is not executed, but compiled */
  _cffi_check_struct_fiemap(0);
}

static void _cffi_check_struct_fiemap_extent(struct fiemap_extent *p)
{
  /* only to generate compile-time warnings or errors */
  (void)p;
  (void)((p->fe_logical) << 1);
  (void)((p->fe_physical) << 1);
  (void)((p->fe_length) << 1);
  (void)((p->fe_flags) << 1);
}
static PyObject *
_cffi_layout_struct_fiemap_extent(PyObject *self, PyObject *noarg)
{
  struct _cffi_aligncheck { char x; struct fiemap_extent y; };
  static Py_ssize_t nums[] = {
    sizeof(struct fiemap_extent),
    offsetof(struct _cffi_aligncheck, y),
    offsetof(struct fiemap_extent, fe_logical),
    sizeof(((struct fiemap_extent *)0)->fe_logical),
    offsetof(struct fiemap_extent, fe_physical),
    sizeof(((struct fiemap_extent *)0)->fe_physical),
    offsetof(struct fiemap_extent, fe_length),
    sizeof(((struct fiemap_extent *)0)->fe_length),
    offsetof(struct fiemap_extent, fe_flags),
    sizeof(((struct fiemap_extent *)0)->fe_flags),
    -1
  };
  (void)self; /* unused */
  (void)noarg; /* unused */
  return _cffi_get_struct_layout(nums);
  /* the next line is not executed, but compiled */
  _cffi_check_struct_fiemap_extent(0);
}

static int _cffi_setup_custom(PyObject *lib)
{
  return _cffi_const_FS_IOC_FIEMAP(lib);
}

static PyMethodDef _cffi_methods[] = {
  {"_cffi_layout_struct_fiemap", _cffi_layout_struct_fiemap, METH_NOARGS, NULL},
  {"_cffi_layout_struct_fiemap_extent", _cffi_layout_struct_fiemap_extent, METH_NOARGS, NULL},
  {"_cffi_setup", _cffi_setup, METH_VARARGS, NULL},
  {NULL, NULL, 0, NULL}    /* Sentinel */
};

#if PY_MAJOR_VERSION >= 3

static struct PyModuleDef _cffi_module_def = {
  PyModuleDef_HEAD_INIT,
  "_cffi__x295accd9xa2b2ad39",
  NULL,
  -1,
  _cffi_methods,
  NULL, NULL, NULL, NULL
};

PyMODINIT_FUNC
PyInit__cffi__x295accd9xa2b2ad39(void)
{
  PyObject *lib;
  lib = PyModule_Create(&_cffi_module_def);
  if (lib == NULL)
    return NULL;
  if (((void)lib,0) < 0 || _cffi_init() < 0) {
    Py_DECREF(lib);
    return NULL;
  }
  return lib;
}

#else

PyMODINIT_FUNC
init_cffi__x295accd9xa2b2ad39(void)
{
  PyObject *lib;
  lib = Py_InitModule("_cffi__x295accd9xa2b2ad39", _cffi_methods);
  if (lib == NULL)
    return;
  if (((void)lib,0) < 0 || _cffi_init() < 0)
    return;
  return;
}

#endif
